package com.reyax.iotdemoplus2;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.CompoundButton;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallbackExtended;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.json.JSONObject;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

public class MainActivity extends AppCompatActivity {
    MQTTHelper mqttHelper;
    private Handler handler = new Handler( );


    TextView dataReceived,systemUTC,humi;
    private Spinner spinner;

    private String[] list = {"1","5","10","30","60"};

    private ArrayAdapter<String> listAdapter;

    int upInterval = 5000;

    //Login FUNC
    static final int FUNC_LOGIN=1;

    SharedPreferences msp;

    private boolean loginOK;

    String deviceId;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu items for use in the action bar
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu, menu);
        return super.onCreateOptionsMenu(menu);
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        msp = this.getSharedPreferences("accountInfo",Context.MODE_PRIVATE);
        loginOK = msp.getBoolean("LOGINOK",false);

        dataReceived = (TextView)findViewById(R.id.dataReceived);
        systemUTC = (TextView)findViewById(R.id.systemUTC);
        humi=(TextView)findViewById(R.id.humi);

        spinner=(Spinner)findViewById(R.id.spinner);
        listAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, list);
        spinner.setAdapter(listAdapter);

        spinner.setOnItemSelectedListener(new OnItemSelectedListener(){
            @Override
            public void onItemSelected(AdapterView adapterView, View view, int position, long id) {

                //mqttHelper.startPub("{}");
                upInterval = Integer.valueOf(spinner.getSelectedItem().toString())*1000;

            }

            @Override
            public void onNothingSelected(AdapterView arg0) {

                Toast.makeText(MainActivity.this, "您沒有選擇任何項目", Toast.LENGTH_LONG).show();

            }
        });

        Switch led1 = (Switch) findViewById(R.id.switch1);

        led1.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    // The toggle is enabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led1\":\"on\"}}}");
                } else {
                    // The toggle is disabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led1\":\"off\"}}}");
                }
            }
        });

        Switch led2 = (Switch) findViewById(R.id.switch2);

        led2.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    // The toggle is enabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led2\":\"on\"}}}");
                } else {
                    // The toggle is disabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led2\":\"off\"}}}");
                }
            }
        });

        Switch led3 = (Switch) findViewById(R.id.switch3);

        led3.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    // The toggle is enabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led3\":\"on\"}}}");
                } else {
                    // The toggle is disabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led3\":\"off\"}}}");
                }
            }
        });

        Switch led4 = (Switch) findViewById(R.id.switch4);

        led4.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    // The toggle is enabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led4\":\"on\"}}}");
                } else {
                    // The toggle is disabled
                    mqttHelper.startPub("{\"action\":\"command/insert\",\"deviceId\":\""+deviceId+"\",\"command\":{\"command\":\"androidCMD\",\"parameters\":{\"led4\":\"off\"}}}");
                }
            }
        });

        //startMqtt();
        handler.postDelayed(runnable,1000);

        if(!loginOK){
            startActivityForResult(new Intent(MainActivity.this, LoginActivity.class), 1);
        }
        else{

            String saveUrl = msp.getString("URL","");

            mqttHelper.setServerUri("tcp://"+saveUrl+":1883");
            mqttHelper.setUsername(msp.getString("EMAIL",""));
            mqttHelper.setPassword(msp.getString("PASSWORD",""));
            mqttHelper.setNetworkId(msp.getString("NETWORKID",""));

            deviceId = msp.getString("DEVICEID","");

            startMqtt();
        }
    }

    @Override
    protected void onStart() {
        super.onStart();
        Log.w("Mqtt", "onStart!");
    }

    @Override
    protected void onResume() {
        super.onResume();
        Log.w("Mqtt", "onResume!");
    }

    @Override
    protected void onPause() {
        super.onPause();
        Log.w("Mqtt", "onPause!");
    }

    @Override
    protected void onStop() {
        super.onStop();
        Log.w("Mqtt", "onStop!");
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        Log.w("Mqtt", "onRestart!");
        if(!mqttHelper.isConnect()) {
            mqttHelper.connect();
            Log.w("Mqtt", "self reconnect!");
        }

    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle presses on the action bar items
        switch (item.getItemId()) {
            case R.id.logout:
                if(mqttHelper.isConnect()) {
                    mqttHelper.disconnect();
                }
                msp.edit().putBoolean("LOGINOK",false).commit();
                Toast.makeText(MainActivity.this, "Logout!", Toast.LENGTH_LONG).show();
                startActivityForResult(new Intent(MainActivity.this, LoginActivity.class), 1);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }


    @Override
    protected void onActivityResult(int requestCode,
                                    int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == FUNC_LOGIN){
            if (resultCode == RESULT_OK){
                String url = data.getStringExtra("LOGIN_URL");
                String uid = data.getStringExtra("LOGIN_USERID");
                String pw = data.getStringExtra("LOGIN_PASSWD");
                String nid = data.getStringExtra("LOGIN_NETWORKID");
                String did = data.getStringExtra("LOGIN_DEVICEID");
                Log.d("RESULT", uid + "/" + pw+ "/" + nid + "/" + did);
                msp.edit().putBoolean("LOGINOK",true).commit();


                mqttHelper.setServerUri("tcp://"+url+":1883");
                mqttHelper.setUsername(uid);
                mqttHelper.setPassword(pw);
                mqttHelper.setNetworkId(nid);

                deviceId = did;

                startMqtt();
            }else{
                //finish();
            }
        }
    }

    @Override
    protected void onDestroy() {

        handler.removeCallbacks(runnable);
        super.onDestroy();

    }

    public static String Local2UTC(){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        sdf.setTimeZone(TimeZone.getTimeZone("gmt"));
        String gmtTime = sdf.format(new Date());
        return gmtTime;
    }



    private Runnable runnable = new Runnable( ) {
        public void run ( ) {

            handler.postDelayed(this,upInterval);
        }
    };


    private void startMqtt(){

        mqttHelper = new MQTTHelper(getApplicationContext());

        mqttHelper.setCallback(new MqttCallbackExtended() {
            @Override
            public void connectComplete(boolean b, String s) {
                MQTTHelper.subscribeToTopic();
                Log.w("Mqtt", "connect to: " + MQTTHelper.serverUri + " OK");

            }

            @Override
            public void connectionLost(Throwable throwable) {
                //MQTTHelper.disconnect();
                if(mqttHelper.isConnect()) {
                    mqttHelper.disconnect();
                }
                Log.w("Mqtt", "connection Lost!!!!");

            }

            @Override
            public void messageArrived(String topic, MqttMessage mqttMessage) throws Exception {
                Log.w("Debug",topic);
                Log.w("Debug",mqttMessage.toString());

                systemUTC.setText(Local2UTC());


                if(topic.contains("api/notification")){
                JSONObject reader = new JSONObject(mqttMessage.toString());
                JSONObject notification = reader.getJSONObject("notification");
                JSONObject para = notification.getJSONObject("parameters");
                if(para.has("temp"))
                dataReceived.setText(para.getString("temp")+"ºC");

                if(para.has("humi"))
                humi.setText(para.getString("humi")+"%");
                }

                if(topic.contains("api/command")){
                JSONObject reader = new JSONObject(mqttMessage.toString());
                JSONObject notification = reader.getJSONObject("command");
                JSONObject para = notification.getJSONObject("parameters");
                if(para.has("button1"))
                    Toast.makeText(MainActivity.this, "Button 1 Pressed!", Toast.LENGTH_SHORT).show();

                if(para.has("button2"))
                    Toast.makeText(MainActivity.this, "Button 2 Pressed!", Toast.LENGTH_SHORT).show();
                }

            }

            @Override
            public void deliveryComplete(IMqttDeliveryToken iMqttDeliveryToken) {

            }
        });

    }
}
